<?php
	error_reporting(E_ERROR);
	$locations = array();
	$thread = "";
	$thread_description = "";
	while ($line = fgets(STDIN)) {
		$line = trim($line, "\n\r");
		// Prevent results when parsing other output that might contain lines matching the format.
		// CodeRunner cannot guarantee that the output being parsed is solely from the where command.
		if (preg_match('/^(Process \d+ stopped$|\s*->)/', $line)) {
			exit(1);
		}
		$matches = array();
		if (preg_match('/^\s*\*?\s*thread #(\d+)(?:,.* queue = \\\'(.*?)\\\')?/', $line, $matches)) {
			$thread = $matches[1];
			if ($matches[2]) {
				$thread_description = $matches[2];
			} else {
				$thread_description = "";
			}
		} else if ($thread) {
			$current = false;
			if (preg_match('/^\s*(\*)?\s*frame #(\d+): 0x[0-9a-f]+ (.*)`(.*?)(?:\(.*?\))? \+ \d+(?: at (.*):(\d+))?/', $line, $matches)) {
				$location = array(
					"thread" => $thread,
					"frame_number" => intval($matches[2]),
					"name" => $matches[4],
					"current" => $matches[1] != "",
					"thread_description" => $thread_description
				);
				if ($matches[5]) {
					$location["file"] = $matches[5];
				} else if ($matches[3]) {
					$location["file"] = $matches[3];
				}
				if (strlen($matches[6]) > 0) {
					$location["line"] = $matches[6];
				}
				array_push($locations, $location);
			}
		}
	}
	echo json_encode($locations);
?>
